#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_UseX64=y
#AutoIt3Wrapper_Change2CUI=y
#AutoIt3Wrapper_Res_Comment=RunInSession
#AutoIt3Wrapper_Res_Description=RunInSession
#AutoIt3Wrapper_Res_Fileversion=1.0.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Joakim Schicht
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
; Sample by Joakim Schicht
; 14.11.12
Global Const $MEM_RELEASE = 0x00008000
Global Const $TOKEN_ALL_ACCESS = 0x000F01FF
Global Const $__WINAPICONSTANT_FORMAT_MESSAGE_ALLOCATE_BUFFER = 0x100
Global Const $__WINAPICONSTANT_FORMAT_MESSAGE_FROM_SYSTEM = 0x1000
Global $PERMISSION = BitOR(0x0002, 0x0400, 0x0008, 0x0010, 0x0020)
Dim $nBytes, $tBuffer
If $cmdline[0] <> 1 Then
	ConsoleWrite("Error: Wrong parameter. Need CmdLine as parameter." & @CRLF)
	ConsoleWrite('Try something like:' & @CRLF)
	ConsoleWrite('RunInSession.exe "%CD%\RunInAnySession 0 0 user YourProgram.exe"' & @CRLF)
	ConsoleWrite('RunInSession.exe "%CD%\RunInAnySession 0 1 system cmd"' & @CRLF)
	Exit
EndIf
$CmdStr = $cmdline[1]
If $CmdStr = "" Or @error Then Exit
_SetPrivilege("SeDebugPrivilege")
$Targets = "trustedinstaller.exe,services.exe,wininit.exe,lsass.exe,spoolsv.exe" ; We try to inject in this order
$TargetProcArray = StringSplit($Targets,",")

For $i = 1 To $TargetProcArray[0]-1
	$TestPiD = _GetPiD($TargetProcArray[$i])
	If Not @error Then
		$NewThread = _Main($TestPiD, $CmdStr)
		If @error then
			ContinueLoop
		Else
			ExitLoop
		EndIf
	Else
		ContinueLoop
	EndIf
Next
If $NewThread<>""  Then
	ConsoleWrite("Remote thread created: " & $NewThread & @CRLF)
Else
;	ConsoleWrite("Something not quite right" & @CRLF)
EndIf
Exit

Func _GetPiD($TargetProcessName)
	Local $aProcs = ProcessList($TargetProcessName), $iPiD = -1
	For $i = 1 To $aProcs[0][0]
		$ret = DllCall("kernel32.dll", "int", "ProcessIdToSessionId", "dword", $aProcs[$i][1], "dword*", 0)
		If Not @error And $ret[0] And ($ret[2] = 0) Then
			$iPiD = $aProcs[$i][1]
			ExitLoop
		EndIf
	Next
	If $iPiD = -1 Then
		ConsoleWrite("Error failed to get PiD of: " & $TargetProcessName & @CRLF)
		Return SetError(1,0,0)
	EndIf
	ConsoleWrite("Host PID of " & $TargetProcessName & ": " & $iPiD & @CRLF)
	Return $iPiD
EndFunc

Func _Main($ParentProc, $CmdStr)
	$StrBin = StringToBinary($CmdStr)
	$StrSize = BinaryLen($StrBin)
	$tBuffer = DllStructCreate("byte ["&$StrSize&"]")
	$ret = DllCall("kernel32.dll", "ptr", "OpenProcess", "dword", $PERMISSION, "int", 0, "dword", $ParentProc)
	If NOT $ret[0] Then
		ConsoleWrite("OpenProcess with PID ("&$ParentProc&"): " & _GetLastErrorMessage() & @CRLF)
		Return SetError(1,0,0)
	Else
;		ConsoleWrite("OpenProcess with PID ("&$ParentProc&"): " & _GetLastErrorMessage() & @CRLF)
		$hProcess = $ret[0]
	EndIf

	Local $call = DllCall("kernel32.dll", "ptr", "GetProcAddress", "ptr", _GetModuleHandle("kernel32.dll"), "str", "WinExec")
	If $call[0] > 0 Then
;		ConsoleWrite("GetProcAddress: " & _GetLastErrorMessage() & @CRLF)
		$WinExec = $call[0]
	Else
		ConsoleWrite("GetProcAddress: " & _GetLastErrorMessage() & @CRLF)
		Return SetError(1,0,0)
	EndIf
	$VirtualAllocEx = _VirtualAllocEx($hProcess, DllStructGetSize($tBuffer))
	If $VirtualAllocEx=0 Then
		ConsoleWrite("VirtualAllocEx: " & _GetLastErrorMessage() & @CRLF)
		Return SetError(1,0,0)
	EndIf

	DllStructSetData($tBuffer,1,$StrBin)
	_WriteProcessMemory($hProcess, $VirtualAllocEx, DllStructGetPtr($tBuffer,1), DllStructGetSize($tBuffer), $nBytes)
;	ConsoleWrite("WriteProcessMemory: " & _GetLastErrorMessage() & @CRLF)
	$hThread = _NtCreateThreadEx($hProcess, $WinExec, $VirtualAllocEx)
	If @error Then
		_VirtualFreeEx($hProcess, $VirtualAllocEx, DllStructGetSize($tBuffer), $MEM_RELEASE)
		Return SetError(1,0,0)
	EndIf
;	ConsoleWrite("$hThread: " & $hThread & @CRLF)
	$ResumeThread = DllCall("Kernel32.dll", "dword", "ResumeThread", "handle", $hThread)
;	ConsoleWrite("ResumeThread: " & _GetLastErrorMessage() & @CRLF)
	$WaitForSingleObject = DllCall("Kernel32.dll", "dword", "WaitForSingleObject", "handle", $hThread, "dword", 1000)
;	ConsoleWrite("WaitForSingleObject: " & _GetLastErrorMessage() & @CRLF)
	_VirtualFreeEx($hProcess, $VirtualAllocEx, DllStructGetSize($tBuffer), $MEM_RELEASE)
	$call = DllCall("Kernel32.dll", "ptr", "GetExitCodeThread", "ptr", $hThread, "dword*", 0)
	ConsoleWrite("GetExitCodeThread: " & $call[2] & @CRLF)
	Return $hThread
EndFunc

Func _VirtualAllocEx($hProcess, $iSize)
	Local $pAddress
	Local $aCall = DllCall("kernel32.dll", "ptr", "VirtualAllocEx", "handle", $hProcess, "ptr", $pAddress, "dword_ptr", $iSize,"dword", 0x3000, "dword", 0x40)
;	If @error Or Not $aCall[0] Then Return SetError(1, 0, 0)
	If @error Or Not $aCall[0] Then Return 0
	Return $aCall[0]
EndFunc

Func _SetPrivilege($Privilege)
    Local $tagLUIDANDATTRIB = "int64 Luid;dword Attributes"
    Local $count = 1
    Local $tagTOKENPRIVILEGES = "dword PrivilegeCount;byte LUIDandATTRIB[" & $count * 12 & "]" ; count of LUID structs * sizeof LUID struct
;	Local $tagTOKENPRIVILEGES = "dword PrivilegeCount;byte LUIDandATTRIB[" & $count * 16 & "]" ; count of LUID structs * sizeof LUID struct
    Local $TOKEN_ADJUST_PRIVILEGES = 0x20
    Local $SE_PRIVILEGE_ENABLED = 0x2

    Local $curProc = DllCall("kernel32.dll", "ptr", "GetCurrentProcess")
;    Local $call = DllCall("advapi32.dll", "int", "OpenProcessToken", "ptr", $curProc[0], "dword", $TOKEN_ADJUST_PRIVILEGES, "ptr*", "")
	Local $call = DllCall("advapi32.dll", "int", "OpenProcessToken", "ptr", $curProc[0], "dword", $TOKEN_ALL_ACCESS, "ptr*", "")
    If Not $call[0] Then Return False
    Local $hToken = $call[3]

    $call = DllCall("advapi32.dll", "int", "LookupPrivilegeValue", "str", "", "str", $Privilege, "int64*", "")
    Local $iLuid = $call[3]

    Local $TP = DllStructCreate($tagTOKENPRIVILEGES)
	Local $TPout = DllStructCreate($tagTOKENPRIVILEGES)
    Local $LUID = DllStructCreate($tagLUIDANDATTRIB, DllStructGetPtr($TP, "LUIDandATTRIB"))

    DllStructSetData($TP, "PrivilegeCount", $count)
    DllStructSetData($LUID, "Luid", $iLuid)
    DllStructSetData($LUID, "Attributes", $SE_PRIVILEGE_ENABLED)

    $call = DllCall("advapi32.dll", "int", "AdjustTokenPrivileges", "ptr", $hToken, "int", 0, "ptr", DllStructGetPtr($TP), "dword", DllStructGetSize($TPout), "ptr", DllStructGetPtr($TPout), "dword*", 0)
	$lasterror = _GetLastError()
	If $lasterror <> 0 Then
		ConsoleWrite("AdjustTokenPrivileges: " & _GetLastErrorMessage() & @CRLF)
		$outPrivilegeCount = DllStructGetData($TPout,"PrivilegeCount")
		$outLUIDandATTRIB = DllStructGetData($TPout,"LUIDandATTRIB")
		ConsoleWrite("$outPrivilegeCount: " &$outPrivilegeCount & @CRLF)
		ConsoleWrite("$outLUIDandATTRIB: " &$outLUIDandATTRIB & @CRLF)
	EndIf
    DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hToken)
    Return ($call[0] <> 0) ; $call[0] <> 0 is success
EndFunc

Func _NtCreateThreadEx($hProcess, $pCode, $pParameter)
	$return = 0
    Local $ret = DllCall("ntdll.dll", "dword", "NtCreateThreadEx", "ptr*", 0, "dword", 0x1FFFFF, "ptr", 0, "ptr", $hProcess, "ptr", $pCode, "ptr", $pParameter, _
                                        "int", 1, "dword", 0, "dword", 0, "dword", 0, "ptr", 0)

    $return = $ret[1]
	If $ret[0] <= 0x7FFFFFFF Then
;		ConsoleWrite("NtCreateThreadEx returned status code 0x" & Hex($ret[0],8) & " -> " & _TranslateErrorCode(_RtlNtStatusToDosError("0x"&Hex($ret[0],8))) & @CRLF)
	Else
		ConsoleWrite("Error: NtCreateThreadEx returned NTSTATUS 0x" & Hex($ret[0],8) & " -> " & _TranslateErrorCode(_RtlNtStatusToDosError("0x"&Hex($ret[0],8))) & @CRLF)
		Return SetError(1, 0, 0)
	EndIf
    Return $return
EndFunc

Func NT_SUCCESS($status)
    If 0 <= $status And $status <= 0x7FFFFFFF Then
        Return True
    Else
        Return False
    EndIf
EndFunc

Func _RtlNtStatusToDosError($Status)
    Local $aCall = DllCall("ntdll.dll", "ulong", "RtlNtStatusToDosError", "dword", $Status)
    If Not NT_SUCCESS($aCall[0]) Then
        ConsoleWrite("Error in RtlNtStatusToDosError: 0x" & Hex($aCall[0], 8) & @CRLF)
        Return SetError(1, 0, $aCall[0])
    Else
        Return $aCall[0]
    EndIf
EndFunc

Func _TranslateErrorCode($ErrCode)
	Local $tBufferPtr = DllStructCreate("ptr")

	Local $nCount = _FormatMessage(BitOR($__WINAPICONSTANT_FORMAT_MESSAGE_ALLOCATE_BUFFER, $__WINAPICONSTANT_FORMAT_MESSAGE_FROM_SYSTEM), _
			0, $ErrCode, 0, $tBufferPtr, 0, 0)
	If @error Then Return SetError(@error, 0, "")

	Local $sText = ""
	Local $pBuffer = DllStructGetData($tBufferPtr, 1)
	If $pBuffer Then
		If $nCount > 0 Then
			Local $tBuffer = DllStructCreate("wchar[" & ($nCount + 1) & "]", $pBuffer)
			$sText = DllStructGetData($tBuffer, 1)
		EndIf
		_LocalFree($pBuffer)
	EndIf

	Return $sText
EndFunc

Func _WriteProcessMemory($hProcess, $pBaseAddress, $pBuffer, $iSize, ByRef $iWritten, $sBuffer = "ptr")
	Local $aResult = DllCall("kernel32.dll", "bool", "WriteProcessMemory", "handle", $hProcess, "ptr", $pBaseAddress, $sBuffer, $pBuffer, _
			"ulong_ptr", $iSize, "ulong_ptr*", 0)
	If @error Then Return SetError(@error, @extended, False)
	$iWritten = $aResult[5]
	Return $aResult[0]
EndFunc

Func _VirtualFreeEx($hProcess, $pAddress, $iSize, $iFreeType)
	Local $aResult = DllCall("kernel32.dll", "bool", "VirtualFreeEx", "handle", $hProcess, "ptr", $pAddress, "ulong_ptr", $iSize, "dword", $iFreeType)
	If @error Then Return SetError(@error, @extended, False)
	Return $aResult[0]
EndFunc

Func _GetLastErrorMessage()
	Local $tBufferPtr = DllStructCreate("ptr")

	Local $nCount = _FormatMessage(BitOR($__WINAPICONSTANT_FORMAT_MESSAGE_ALLOCATE_BUFFER, $__WINAPICONSTANT_FORMAT_MESSAGE_FROM_SYSTEM), _
			0, _GetLastError(), 0, $tBufferPtr, 0, 0)
	If @error Then Return SetError(@error, 0, "")

	Local $sText = ""
	Local $pBuffer = DllStructGetData($tBufferPtr, 1)
	If $pBuffer Then
		If $nCount > 0 Then
			Local $tBuffer = DllStructCreate("wchar[" & ($nCount + 1) & "]", $pBuffer)
			$sText = DllStructGetData($tBuffer, 1)
		EndIf
		_LocalFree($pBuffer)
	EndIf

	Return $sText
EndFunc

Func _LocalFree($hMem)
	Local $aResult = DllCall("kernel32.dll", "handle", "LocalFree", "handle", $hMem)
	If @error Then Return SetError(@error, @extended, False)
	Return $aResult[0]
EndFunc

Func _GetLastError($curErr = @error, $curExt = @extended)
	Local $aResult = DllCall("kernel32.dll", "dword", "GetLastError")
	Return SetError($curErr, $curExt, $aResult[0])
EndFunc

Func _FormatMessage($iFlags, $pSource, $iMessageID, $iLanguageID, ByRef $pBuffer, $iSize, $vArguments)
	Local $sBufferType = "struct*"
	If IsString($pBuffer) Then $sBufferType = "wstr"
	Local $aResult = DllCall("Kernel32.dll", "dword", "FormatMessageW", "dword", $iFlags, "ptr", $pSource, "dword", $iMessageID, "dword", $iLanguageID, _
			$sBufferType, $pBuffer, "dword", $iSize, "ptr", $vArguments)
	If @error Then Return SetError(@error, @extended, 0)
	If $sBufferType = "wstr" Then $pBuffer = $aResult[5]
	Return $aResult[0]
EndFunc

Func _GetModuleHandle($sModuleName)
	Local $sModuleNameType = "wstr"
	If $sModuleName = "" Then
		$sModuleName = 0
		$sModuleNameType = "ptr"
	EndIf
	Local $aResult = DllCall("kernel32.dll", "handle", "GetModuleHandleW", $sModuleNameType, $sModuleName)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aResult[0]
EndFunc
